unit ServerMethodsUnit1;

interface

uses
  SysUtils, Classes, DSServer, DBXJSON, DBXFirebird, FMTBcd, DB, SqlExpr;

type
{$METHODINFO ON}
  TServerMethods1 = class(TDataModule)
    FBCONNECTION: TSQLConnection;
    EmpTable: TSQLDataSet;
  private
    { Private declarations }
  public
    { Public declarations }
    function EchoString(Value: string): string;
    function ReverseString(Value: string): string;
    function Add (i, j: Integer): Integer;
    function TableData: TJSONObject;
  end;
{$METHODINFO OFF}

implementation

{$R *.dfm}

uses StrUtils;

function TServerMethods1.Add(i, j: Integer): Integer;
begin
  Result := i + j;
end;

function TServerMethods1.EchoString(Value: string): string;
begin
  Result := Value;
end;

function TServerMethods1.ReverseString(Value: string): string;
begin
  Result := StrUtils.ReverseString(Value);
end;

function TServerMethods1.TableData: TJSONObject;
var
  dataArray, subArray: TJSONArray;
  metaArray: TJSONArray;
  I: Integer;
begin
  EmpTable.Open;
  dataArray:= TJSONArray.Create;

  while not EmpTable.EOF do
  begin
    subArray := TJSONArray.Create;
    for I := 0 to EmpTable.FieldCount - 1 do
      subArray.Add(EmpTable.Fields[I].AsString);
    dataArray.AddElement(subArray);
    EmpTable.Next;
  end;

  metaArray := TJSonArray.Create;
  for I := 0 to EmpTable.FieldDefs.Count - 1 do
  begin
    metaArray.Add (TJSONObject.Create(
      TJSONPair.Create('sTitle', EmpTable.FieldDefs[I].Name)));
  end;

  Result := TJSONObject.Create;
  Result.AddPair(TJSONPair.Create('aaData', dataArray));
  Result.AddPair(TJSONPair.Create('aoColumns', metaArray));
end;

end.

